// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.5.1
// - protoc             v3.21.12
// source: yandex/cloud/datasphere/v2/s3_service.proto

package datasphere

import (
	context "context"
	operation "github.com/yandex-cloud/go-genproto/yandex/cloud/operation"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.64.0 or later.
const _ = grpc.SupportPackageIsVersion9

const (
	S3Service_Activate_FullMethodName   = "/yandex.cloud.datasphere.v2.S3Service/Activate"
	S3Service_Deactivate_FullMethodName = "/yandex.cloud.datasphere.v2.S3Service/Deactivate"
)

// S3ServiceClient is the client API for S3Service service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
//
// A set of methods for managing S3 configurations.
type S3ServiceClient interface {
	// Activates shared s3 for project
	Activate(ctx context.Context, in *ActivateS3Request, opts ...grpc.CallOption) (*operation.Operation, error)
	// Deactivates shared s3 for project
	Deactivate(ctx context.Context, in *DeactivateS3Request, opts ...grpc.CallOption) (*operation.Operation, error)
}

type s3ServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewS3ServiceClient(cc grpc.ClientConnInterface) S3ServiceClient {
	return &s3ServiceClient{cc}
}

func (c *s3ServiceClient) Activate(ctx context.Context, in *ActivateS3Request, opts ...grpc.CallOption) (*operation.Operation, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(operation.Operation)
	err := c.cc.Invoke(ctx, S3Service_Activate_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *s3ServiceClient) Deactivate(ctx context.Context, in *DeactivateS3Request, opts ...grpc.CallOption) (*operation.Operation, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(operation.Operation)
	err := c.cc.Invoke(ctx, S3Service_Deactivate_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// S3ServiceServer is the server API for S3Service service.
// All implementations should embed UnimplementedS3ServiceServer
// for forward compatibility.
//
// A set of methods for managing S3 configurations.
type S3ServiceServer interface {
	// Activates shared s3 for project
	Activate(context.Context, *ActivateS3Request) (*operation.Operation, error)
	// Deactivates shared s3 for project
	Deactivate(context.Context, *DeactivateS3Request) (*operation.Operation, error)
}

// UnimplementedS3ServiceServer should be embedded to have
// forward compatible implementations.
//
// NOTE: this should be embedded by value instead of pointer to avoid a nil
// pointer dereference when methods are called.
type UnimplementedS3ServiceServer struct{}

func (UnimplementedS3ServiceServer) Activate(context.Context, *ActivateS3Request) (*operation.Operation, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Activate not implemented")
}
func (UnimplementedS3ServiceServer) Deactivate(context.Context, *DeactivateS3Request) (*operation.Operation, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Deactivate not implemented")
}
func (UnimplementedS3ServiceServer) testEmbeddedByValue() {}

// UnsafeS3ServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to S3ServiceServer will
// result in compilation errors.
type UnsafeS3ServiceServer interface {
	mustEmbedUnimplementedS3ServiceServer()
}

func RegisterS3ServiceServer(s grpc.ServiceRegistrar, srv S3ServiceServer) {
	// If the following call pancis, it indicates UnimplementedS3ServiceServer was
	// embedded by pointer and is nil.  This will cause panics if an
	// unimplemented method is ever invoked, so we test this at initialization
	// time to prevent it from happening at runtime later due to I/O.
	if t, ok := srv.(interface{ testEmbeddedByValue() }); ok {
		t.testEmbeddedByValue()
	}
	s.RegisterService(&S3Service_ServiceDesc, srv)
}

func _S3Service_Activate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ActivateS3Request)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(S3ServiceServer).Activate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: S3Service_Activate_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(S3ServiceServer).Activate(ctx, req.(*ActivateS3Request))
	}
	return interceptor(ctx, in, info, handler)
}

func _S3Service_Deactivate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeactivateS3Request)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(S3ServiceServer).Deactivate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: S3Service_Deactivate_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(S3ServiceServer).Deactivate(ctx, req.(*DeactivateS3Request))
	}
	return interceptor(ctx, in, info, handler)
}

// S3Service_ServiceDesc is the grpc.ServiceDesc for S3Service service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var S3Service_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "yandex.cloud.datasphere.v2.S3Service",
	HandlerType: (*S3ServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Activate",
			Handler:    _S3Service_Activate_Handler,
		},
		{
			MethodName: "Deactivate",
			Handler:    _S3Service_Deactivate_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "yandex/cloud/datasphere/v2/s3_service.proto",
}
